import nanicrypt

pub = """-----BEGIN RSA PUBLIC KEY-----
MIGJAoGBAKl/Mg0tBz6VMBiekZ2UzNnRsdgQ0SqYwMKUPza6F4xeWMwGhs0R7zVA
bpPyISr/1uKfaxqgsUFCXG6nitirMCQVF1PzkCoK6rfRWD+dueYL7Q3zKacwFi41
lq1QPnT5Xrda2tGXWzTmADbabCZHd81+EI7VLVfGBE+2to5nrZX1AgMBAAE=
-----END RSA PUBLIC KEY-----"""

priv = """-----BEGIN RSA PRIVATE KEY-----
MIICYQIBAAKBgQCpfzINLQc+lTAYnpGdlMzZ0bHYENEqmMDClD82uheMXljMBobN
Ee81QG6T8iEq/9bin2saoLFBQlxup4rYqzAkFRdT85AqCuq30Vg/nbnmC+0N8ymn
MBYuNZatUD50+V63WtrRl1s05gA22mwmR3fNfhCO1S1XxgRPtraOZ62V9QIDAQAB
AoGAezvIhz3i04SiqHO5yYmjewb0N/TaLw9Kru4cG80nS95Yz1Y7ciQE+IG1JAna
RaoncTOZKo4E8j6ud6GGM/0+4l5jylNsGNn0aTlwjJ3s20FYSfDpAeUJ0H2kFZ8A
7S7sezC6BD++K5hr6sJD5osUieO1vM2SMpOBPjjFklq3CkECRQDirOyQ8kJzOgx3
RDQ6+VJSQA14huw8UnLw2PMgYrAXrlcF0yMybZNO4GbUkTAhjQ0mwVgSjvJtvUxY
u3CVY4HxNrd5pQI9AL9snsmY3ORXuEI+C8XAL+vTuRY0iVdRGUv+FVZgWVUWXGb2
M+cb+rs0Ptxu1F0yGfElQ4RedWBiU8jaEQJFAJ4JajX0cZfclOxiRPgI8/gcaEfr
6bB022ZIG9osdBFOn6WT+yohc16+3XK+dwwtR0oJ6tmliCgynpQOuwOsiOAgAfNx
Aj0AoKQw5RFpXh7XPJABJSTRkmCNVLsl/qbKSeGiWmhkz2kChk1a5TmvwmZn0mkX
wlYHOz2AWZdDfW1GzqlhAkR54fEH2muPLIMPaNMtjbnEFcr7+xZf3zLrsROcUKZA
Atv9rue3ySMXINR3T8Fyg0QEB4Uh8h7aypEDEN9RKhlDHkdybg==
-----END RSA PRIVATE KEY-----"""

# please don't use these keys, they are intended for testing only.

salt = "<testing nanicrypt>"
data = {"this_is": "nanicrypt", "test": True}

client = nanicrypt.ClientNaniCrypt(pub, salt)
server = nanicrypt.ServerNaniCrypt(priv, salt)
enc1 = client.encrypt(data)
print("client encrypted:", enc1.data)
srvdec1 = server.decrypt(enc1.data, enc1.sign)
print("server decrypted:", srvdec1.data)
srvenc1 = server.encrypt({"success": True, "list": ["1", "2", "3"], "echo": srvdec1.data}, enc1.key)
print("server encrypted:", srvenc1)
cldec1 = client.decrypt(srvenc1, enc1.key)
print("client decrypted: ", cldec1)

assert cldec1["echo"] == data

# server test
net = nanicrypt.NaniCryptNetworking(pub, "http://127.0.0.1/nanicrypt", salt)
a = net.make_request("example.php", data)
print(a)

assert a["echo"] == data